<?php
/**
 * @version		1.0.5
 * @package		Joomla
 * @subpackage	Edocman
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2011 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );
jimport('joomla.application.component.model');
/**
 * Edocman Component Import Model
 *
 * @package		Joomla
 * @subpackage	Edocman
 * @since 1.5
 */
 
 /***** import composant jifile lucene *******/
$path_jifile = JPATH_SITE.'/administrator/components/com_jifile/models/lucene.php';

if(file_exists($path_jifile))
{
	require_once($path_jifile);
}
/********************************************/
 
class EdocmanModelImport extends JModel
{	
	/**
	 * Store the configuration data
	 *
	 * @param array $post
	 */
	function store($data) 
	{
		$db = & JFactory::getDbo() ;
		jimport('joomla.filesystem.folder') ;
		
		$config = EdocmanHelper::getConfig() ;						
		$row = JTable::getInstance('Document', 'EdocmanTable') ;
		$categoryId = (int) $data['category_id'] ;
		$data['folder'] = trim($data['folder']);				
		$path = strlen($data['folder']) ? $config->documents_path.'/'.$data['folder'] : $config->documents_path ;
		//Store category ID in $_POST array, use for permission setting				
		$_POST['jform']['category_id'] = $categoryId ;
		if ($data['exts']) {
			$fileExts = explode(',', $data['exts']) ;
			for ($i = 0 , $n = count($fileExts) ; $i < $n ; $i++) {
				$fileExts[$i] = trim($fileExts[$i]) ;
			}
			$filter = implode('|', $fileExts); 		
		} else {
			$filter = '.*' ;		
		}

		$files = JFolder::files($path, $filter) ;
		
		if (count($files)) 
		{
			foreach ($files as $file)
			{
				$documentData = array();
				
				//titre du document sans extension pour l'import
				$fileSansExt = explode('.', $file);
				
				/*dump($file);
				dump($fileSansExt);*/
				
				$documentData['title']  = $fileSansExt[0];
				$documentData['original_filename'] = $file;
				
				if ($data['folder']) {
					$documentData['filename'] = $data['folder'].'/'.$file;
				} else {
					$documentData['filename'] = $file;
				}
				
				/****** fonction ajout enregistrer le contenu du document dans la description*****/
				//si le composant existe
				if(file_exists(JPATH_SITE.'/administrator/components/com_jifile/models/lucene.php'))
				{	
					$component = JComponentHelper::getComponent("com_jifile", $strict);
					
					//si le composant est activer
					if($component->enabled)
					{
						// si le filename(category/nomfichier.extension) enregistrer est rempli
						if($documentData['filename'] != null)
						{
							$fields = array('title'=>'', 'subject'=>'', 'description'=>'', 'creator'=>'', 'keywords'=>'', 'body'=>'');
							
							$model = new JifileModelLucene();
							
							//recupration du document via le path($savedFilePath)
							$ifiledoc = $model::getLuceneDoc($config->documents_path.'/'.$documentData['filename'], true, false);
							$ifiledoc = array_merge($fields, (empty($ifiledoc) ? array() : $ifiledoc));
							
							$description = htmlentities($ifiledoc['body'], ENT_COMPAT);
							
							//dump($description, "description");
							
							//ajout de la donne description dans la table a sauvegarder
							$documentData['description'] = $description;
						}
					}
				}
				/******************************************************************************/
				
				//Check if the document is existed or not
				$sql = 'SELECT COUNT(id) FROM #__edocman_documents WHERE filename="'.$documentData['filename'].'"';
				$db->setQuery($sql) ;
				$total = (int)$db->loadResult();
				if ($total >0)
					continue ;
				$documentData['id'] = 0 ;
				$row->bind($documentData);
				$row->check();
				$row->store();								
			}
		}	
									
		return true;
	}
}